data {
  $iif(!$window(@Raw),window -k0nz @Raw,$null)
  echo -t @Raw $1-
}
lang { return $iif(!$readini(lang/lang_ $+ $readnick($1,lang) $+ .db,$2,$3), $readini(lang/lang_en.db,$2,$3), $readini(lang/lang_ $+ $readnick($1,lang) $+ .db,$2,$3)) }
netconf { return $readini(services.conf,$1,$2) }
writeconf { writeini services.conf $1 $2 $3- }
report { sockwrite -tn serv $+(:,$netconf(system,nickname)) PRIVMSG $netconf(system,report) $+(:,$1-) }
sysmsg { sockwrite -tn serv $+(:,$netconf(system,nickname)) PRIVMSG $1 $+(:,$2-) }
sysjoin { sockwrite -tn serv $+(:,$netconf(system,nickname)) JOIN $1 | sockwrite -tn serv $+(:,$netconf(system,nickname)) TOPIC $1 $netconf(system,nickname) $ctime : $+ $remove($read(data/set_topics.txt, s, $1 $+ :),$1 $+ :) | .sockwrite -tn serv $+(:,$netconf(system,nickname)) MODE $1 $readchan($1,modes) | .sockwrite -tn serv $+(:,$netconf(server,server)) MODE $1 +o $netconf(system,nickname) |  report JOINED: $1 (inchan) }
syspart { sockwrite -tn serv $+(:,$netconf(system,nickname)) PART $1 $2- | report PARTED: $1 $2- }
sysnotice { sockwrite -tn serv $+(:,$netconf(system,nickname)) NOTICE $1 $+(:,$2-) }
sysnotice2 { sockwrite -tn serv $+(:,$netconf(system,service2)) NOTICE $1 $+(:,$2-) }
chanopuser { sockwrite -tn serv $+(:,$netconf(system,nickname)) MODE $1 $2- }
chanmode { sockwrite -tn serv $+(:,$netconf(system,nickname)) MODE $1 $2- }
addy { return $readini(data/id.db,id,$readclient($1,host)) }
userhost { return $+($readclient($1,ident),@,$readclient($1,host)) }

; pending items
writepending { writeini data/pending.db $1 $2 $3- }
readpending { return $readini(data/pending.db,$1,$2) }
delpending { remini data/pending.db $1 $2 }

; Client Data

addclient { writeini data/clients.db $1 $2 $3- }
readclient { return $readini(data/clients.db,$1,$2) }
delclient { remini data/clients.db $1 }
swapclient { 
  addclient $2 nickname $2
  addclient $2 ident $readclient($remove($1,:),ident)
  addclient $2 host $readclient($remove($1,:),host)
  addclient $2 server $readclient($remove($1,:),server)
  addclient $2 time $readclient($remove($1,:),time)
  delclient $remove($1,:)
}

; Channel Data

addchan { writeini data/channels.db $1 $2 $3- }
delchan { remini data/channels.db $1 $2 }
wipechan { remini data/channels.db $1 }
readchan { return $readini(data/channels.db,$1,$2) }
userautoop { writeini data/access/autoop.db $1 $2 $3- }
userautojoin { writeini data/access/autojoin.db $1 $2 $3- }
setuserchaninfo { writeini data/access/infolines.db $1 $2 $3- }
userautovoice { writeini data/access/autovoice.db $1 $2 $3- }
readuserautovoice { return $readini(data/access/autovoice.db,$1,$2) }
readuserautojoin { return $readini(data/access/autojoin.db,$1,$2) }
readuserautoop { return $readini(data/access/autoop.db,$1,$2) }
readison { return $readini(data/activechans.db,$1,$2) }
readuserinfoline { return $readini(data/access/infolines.db,$1,$2) }
writetopic { write data/set_topics.txt $1 $+ : $2- }
removetopic { write -ds $+ $1 $+ : data/set_topics.txt }
removeban { .sockwrite -tn serv :SysOp MODE $1 -b $2 }
; Access Data

addaccess { writeini $+(data/access/,$3,.db) $1 $2 $4- }
delaccess { remini $+(data/access/,$3,.db) $1 $2 }
readaccess { return $readini($+(data/access/,$3,.db),$1,$2) }

; Nickname Data

addnick { writeini data/nicknames.db $1 $2 $3- }
wipenick { remini data/nicknames.db $1 }
delnick { remini data/nicknames.db $1 $2 }
readnick { return $readini(data/nicknames.db,$1,$2) }
readpass { return $decode($1,m) }
writepass { return $encode($1,m) }

; Seen data
addseen { writeini data/seen.db $1 $2 $3- }
readseen { return $readini(data/seen.db,seen,$1) }

; IRCOP Data

addadmin { writeini data/admin.db $1 $2 $3- }
deladmin { remini data/admin.db $1 $2 }
wipeadmin { remini data/admin.db $1 }
readadmin { return $readini(data/admin.db,$1,$2) }

; Misc Aliases

a_ctcp {
  set %RT_Data $gettok($3-,1,32)
  set %RT_Data $gettok(%RT_Data,2,1)
  if (%RT_Data == PING) { sockwrite -tn serv : $+ $2 NOTICE $1 $3- | return }
  if (%RT_Data == VERSION) { sockwrite -tn serv : $+ $2 NOTICE $1 :VERSION SysOP Services $netconf(network,version) Bozza & Borderlad  2007 | return }
  if (%RT_Data == TIME) { sockwrite -tn serv : $+ $2 NOTICE $1 :TIME $time $+   | return }
  if (%RT_Data == SEX) { sockwrite -tn serv : $+ $2 NOTICE $1 :SEX No I will not have sex with you. $+   | return }
  else { sockwrite -tn serv : $+ $2 NOTICE $1 : $+ %RT_Data Unknown CTCP Request. | Return }
}
axs.levels.name {
  if ($1 == 1) { return Lamer }
  if ($1 == 2) { return Friend }
  if ($1 == 3) { return Operator }
  if ($1 == 4) { return Co-Owner }
  if ($1 == 5) { return Owner }
  else { return No-Access }
}

axs.levels.number {
  if ($1 == Lamer) { return 1 }
  if ($1 == Friend) { return 2 }
  if ($1 == Operator) { return 3 }
  if ($1 == Co-Owner) { return 4 }
  if ($1 == Owner) { return 5 }
  else { return No-Access }
}
